use 5.006;
use Config;
use ExtUtils::MakeMaker;

# Cpp definitions (part of CPPFLAGS).
$DEFINE = '';

# Includes  (part of CPPFLAGS).
$INC  = '-I/usr/local/include';

# Libraries (part of LDFLAGS).
$LIBS = ['-L/usr/local/lib -lidnkitlite'];

# Flags for ld to create a shared library.
$LDDLFLAGS = "$Config{lddlflags} -Wl,-rpath -Wl,/usr/local/lib";

######################################################################
# Subdirectories.
$DIR  = ['IDNA', 'IDNA2008', 'IDNAFactory', 'Result'];

# Joined-string representation of $LIBS.
my $LIBS_joined = join(', ', map {"'$_'"} @$LIBS);

# Create Makefile.PL files in sub-directories.
foreach my $dir (@$DIR) {
    open(IN, '<', "$dir/Makefile.PL.in")
	or die "failed to open the file, $!: $dir/Makefile.PL.in\n";
    open(OUT, '>', "$dir/Makefile.PL")
	or die "failed to open the file, $!: $dir/Makefile.PL\n";
    while (<IN>) {
	s/\@DEFINE\@/$DEFINE/eg;
	s/\@INC\@/$INC/eg;
	s/\@LIBS\@/$LIBS_joined/eg;
	s/\@LDDLFLAGS\@/$LDDLFLAGS/eg;
	print OUT;
    }
    close(OUT);
    close(IN);
}

# Create Makefile.PL file of this directory.
WriteMakefile(
    NAME              => 'IDNKit',
    DISTNAME          => 'idnkit-perl', 
    VERSION_FROM      => 'IDNA/IDNA.pm', # finds $VERSION
    PREREQ_PM         => {}, # e.g., Module::Name => 1.1
    ABSTRACT          => 'Perl API for idnkit', # retrieve abstract from module
    AUTHOR            => 'Japan Registry Services Co., Ltd.(JPRS)',
    DIR               => $DIR,
    dist              => {COMPRESS => 'bzip2 --best', SUFFIX => '.bz2'},
);
